package es.prodevelop.tilecache.generator.impl;

import es.prodevelop.gvsig.mini.common.impl.CollectionQuickSort;
import es.prodevelop.gvsig.mini.common.impl.Tile;
import es.prodevelop.gvsig.mini.geom.Pixel;
import es.prodevelop.tilecache.generator.ITileSorter;

public class DistanceFromCenterQuickSorter extends CollectionQuickSort implements ITileSorter {
		
	private Pixel center;
	private Pixel tilePxDiv2;

	@Override
	public boolean less(Object x, Object y) {		
		double e1 = (((Tile)x).distanceFromCenter.add(tilePxDiv2)).distance(center);		
		double e2 = (((Tile)y).distanceFromCenter.add(tilePxDiv2)).distance(center);
		
		return e1<e2;
	}
	
	public void setCenterPixel(final Pixel center) {
		this.center = center;
	}
	
	public void setTileSize(final int tileSizePx) {
		tilePxDiv2 = new Pixel((tileSizePx / 2), (tileSizePx / 2));
	}

	public void sortTiles(Tile[] tiles, int centerPixelX, int centerPixelY,
			int tileSizePx) {
		this.setCenterPixel(new Pixel(centerPixelX, centerPixelY));
		this.setTileSize(tileSizePx);		
		this.quicksort(tiles);
	}

}
